start

[Transaction(TransactionMode.Manual)]

[Regeneration(RegenerationOption.Manual)]

public class cmdDuctWall : IExternalCommand

{

    public Result Execute(ExternalCommandData cmdData, ref string msg, ElementSet elements)

    {

        UIApplication uiApp = cmdData.Application;

        UIDocument uiDoc = cmdData.Application.ActiveUIDocument;

        Document doc = uiDoc.Document;

        Selection sel = uiDoc.Selection;

        Transaction ts = new Transaction(uiDoc.Document, "delete");

        ts.Start();

        //加载链接文件

        FilteredElementCollector collector = new FilteredElementCollector(doc);//

        collector.OfClass(typeof(Instance)).OfCategory(BuiltInCategory.OST_RvtLinks);//RevitLinkType

        List<string> listPath = GetLinkFilePaths(doc);

        Duct duct = doc.GetElement(sel.PickObject(ObjectType.Element, "duct")) as Duct;

        foreach (Element elDoc in collector)

        {

            Instance ins = elDoc as Instance;

            if (ins != null)

            {

                Transform transForm = ins.GetTransform();

                string strKey = elDoc.Name.Substring(, elDoc.Name.IndexOf(".rvt"));//找到链接文件名称

                string strPath = GetLinkPath(listPath, strKey);

                Document docLink = uiApp.Application.OpenDocumentFile(strPath);

                List<Wall> listWall = FindDuctWall(doc, duct, docLink, ins.GetTransform().Origin);

                TaskDialog.Show("count", listWall.Count.ToString());

                List<Wall> listWall1 = FindDuctWall(doc, duct);

                TaskDialog.Show("count", listWall1.Count.ToString());

            }

        }

        ts.Commit();

        return Result.Succeeded;

    }

    /// <summary>

    /// 找到当前文档穿过的墙

    /// </summary>

    /// <param name="doc"></param>

    /// <param name="duct"></param>

    /// <returns></returns>

    public List<Wall> FindDuctWall(Document doc, Duct duct)

    {

        List<Wall> listWall = new List<Wall>();

        //找到outLine

        BoundingBoxXYZ bb = duct.get_BoundingBox(doc.ActiveView);

        Outline outline = new Outline(bb.Min, bb.Max);

        //WinFormTools.MsgBox(bb.Min + "|" + bb.Max);

        //

        FilteredElementCollector collector = new FilteredElementCollector(doc);

        BoundingBoxIntersectsFilter invertFilter = new BoundingBoxIntersectsFilter(outline, false);

        IList<Element> noIntersectWalls = collector.OfClass(typeof(Wall)).WherePasses(invertFilter).ToElements();

        foreach (Element el in noIntersectWalls)

        {

            Wall wall = el as Wall;

            if (wall != null)

                listWall.Add(wall);

        }

        return listWall;

    }

    /// <summary>

    /// 找到穿过链接文件的墙

    /// </summary>

    /// <param name="doc"></param>

    /// <param name="duct"></param>

    /// <param name="docLink"></param>

    /// <param name="xyz">依稀量</param>

    /// <returns></returns>

    public List<Wall> FindDuctWall(Document doc, Duct duct, Document docLink, XYZ xyz)

    {

        List<Wall> listWall = new List<Wall>();

        //找到outLine

        BoundingBoxXYZ bb = duct.get_BoundingBox(doc.ActiveView);

        Outline outline = new Outline(bb.Min - xyz, bb.Max - xyz);

        //

        FilteredElementCollector collector = new FilteredElementCollector(docLink);

        BoundingBoxIntersectsFilter invertFilter = new BoundingBoxIntersectsFilter(outline, false);

        IList<Element> noIntersectWalls = collector.OfClass(typeof(Wall)).WherePasses(invertFilter).ToElements();

        foreach (Element el in noIntersectWalls)

        {

            Wall wall = el as Wall;

            if (wall != null)

                listWall.Add(wall);

        }

        return listWall;

    }

    /// <summary>

    /// 取得链接文件路径

    /// </summary>

    /// <param name="doc"></param>

    /// <returns></returns>

    public List<string> GetLinkFilePaths(Document doc)

    {

        List<string> listPath = new List<string>();

        foreach (ElementId elId in ExternalFileUtils.GetAllExternalFileReferences(doc))

        {

            if (doc.get_Element(elId).IsExternalFileReference())

            {

                ExternalFileReference fileRef = doc.get_Element(elId).GetExternalFileReference();

                if (ExternalFileReferenceType.RevitLink == fileRef.ExternalFileReferenceType)

                    listPath.Add(ModelPathUtils.ConvertModelPathToUserVisiblePath(fileRef.GetAbsolutePath()));

            }

        }

        return listPath;

    }

    /// <summary>

    /// 根据链接文件名称找到对应链接路径,模糊匹配,待改进

    /// </summary>

    /// <param name="listPath"></param>

    /// <param name="strKey"></param>

    /// <returns></returns>

    public string GetLinkPath(List<string> listPath, string strKey)

    {

        foreach (string strPath in listPath)

        {

            if (strPath.Contains(strKey))

                return strPath;

        }

        return "";

    }

}

url:http://greatverve.cnblogs.com/p/revit-api-ductWall.html

Revit API找到风管穿过的墙(当前文档和链接文档)的更多相关文章

  1. Openstack api 学习文档 & restclient使用文档

    Openstack api 学习文档 & restclient使用文档 转载请注明http://www.cnblogs.com/juandx/p/4943409.html 这篇文档总结一下我初 ...

  2. API接口文档中将Swagger文档转Word 文档

    一般的开发工作,尤其是API接口的开发工作,首先要有开发文档,接口说明文档 ok,后来开发完毕了 和页面联调,或者是和第三方联调的时候, 这个时候,SA systeam admin 就会开始直接让开发 ...

  3. 一个非常适合IT团队的在线API文档、技术文档工具 (ShowDoc)

    在逸橙呆了不到两年,开发时后端都有开发接口API,来到数库,好多后端开发和前端沟通是还是发doc文档,很不方便,我向cto反应,自己找到这个,老乡田雷(php,隔壁村的)也用过,可能某些原因选择其他的 ...

  4. [工具推荐]制作基于Dash的本地文档方便搜索文档api和内容

    [版权声明]:本文章由danvid发布于http://danvid.cnblogs.com/,如需转载或部分使用请注明出处 最近在看es的文档,发现查起api来真的很麻烦,很多现在开源的文档都没有查询 ...

  5. Revit API改变风管及管件尺寸

    start , , )) < , , -)) < , dHeight = ;             ConnectorSetIterator csi = fi.MEPModel.Conn ...

  6. Revit API移动风管

    移动风管曲线就可以移动风管 , , ));//向上移动3         ts.Commit();         return Result.Succeeded;     } } url:http: ...

  7. C# : 操作Word文件的API - (将C# source中的xml注释转换成word文档)

    这篇博客将要讨论的是关于: 如何从C#的source以及注释, 生成一份Word格式的关于各个类,函数以及成员变量的说明文档. 他的大背景如下...... 最近的一个项目使用C#, 分N个模块, 在项 ...

  8. Revit API根据链接文件开洞

    开洞信息数据: ]);             ;                     ;                     ;                     ;          ...

  9. 关于Revit API修改元素参数的问题?

    >ADN: DEVR3894  >ADN service level: Professional  >产品:Revit MEP 2012  >版本:2012  >语言:中 ...

随机推荐

  1. AC自动机(病毒侵袭 )

    题目链接:https://cn.vjudge.net/contest/280743#problem/B 题目大意:中文题目 具体思路:AC自动机模板题,编号的时候注意,是按照给定的id进行编号的.然后 ...

  2. CodeForces Contest #1114: Round #538 (Div. 2)

    比赛传送门:CF #1114. 比赛记录:点我. 又 FST 了. [A]Got Any Grapes? 题意简述: 有三个人,第一个人需要吃绿色葡萄至少 \(a\) 个,第二个人需要吃绿色和紫色葡萄 ...

  3. python3之模块urllib

    urllib是python内置的HTTP请求库,无需安装即可使用,它包含了4个模块: request:它是最基本的http请求模块,用来模拟发送请求 error:异常处理模块,如果出现错误可以捕获这些 ...

  4. mysqldump只导出表结构或只导出数据的实现方法【转】

    mysql mysqldump 只导出表结构 不导出数据 mysqldump --opt -d 数据库名 -u root -p > xxx.sql 备份数据库 #mysqldump 数据库名 & ...

  5. H5页面关于android软键盘弹出顶起底部元素的解决方案

    应用场景:用div在移动端页面设置一个底部工具栏,css的代码大概如下: .tool{ width: 100%; height: 60px; position: fixed; left: 0px; b ...

  6. AngularJS里面$emit, $broadcast,$on,$http.Jsonp,constant是使用笔记

    本片主要介绍$emit, $broadcast,$on经常开发的用法!

  7. protected

    protected  继承访问权限 在同一包中可以访问protected成员. 继承状态可以访问protected成员 在不同包中非继承不可以访问protected成员.

  8. hdu 1856 求集合里元素的个数 输出最大的个数是多少

    求集合里元素的个数 输出最大的个数是多少 Sample Input41 23 45 61 641 23 45 67 8 Sample Output42 # include <iostream&g ...

  9. 实操一下<python cookbook>第三版1

    这几天没写代码, 练一下代码. 找的书是<python cookbook>第三版的电子书. *这个操作符,运用得好,确实少很多代码,且清晰易懂. p = (4, 5) x, y = p p ...

  10. BZOJ 1878 HH的项链 | 主席树

    题意 询问区间有多少不同的数. 题解 和Luogu 1903一样,这道题也是用pre数组来求区间不同数的个数,这里pre[i]表示a[i]上一次出现的位置 +1,询问相当于查询区间内有多少pre小于等 ...